summaryrefslogtreecommitdiff
path: root/libdde-linux26/libdde_linux26/mk/rel2abs.sh
diff options
context:
space:
mode:
authorSamuel Thibault <samuel.thibault@ens-lyon.org>2013-07-27 22:11:24 +0000
committerSamuel Thibault <samuel.thibault@ens-lyon.org>2013-07-27 22:11:24 +0000
commitce6a36c7f7c88e7ca0fda816f9282237bb86829d (patch)
tree611bf9beb2281d34260ca87fc189a0ddc864819a /libdde-linux26/libdde_linux26/mk/rel2abs.sh
parentbb9d6cd642f9189b8102d566c8c46a6de1d2c5f7 (diff)
parent4fbe7358c7747a9165f776eb19addbb9baf7def2 (diff)
Merge branch 'upstream-merged'
Diffstat (limited to 'libdde-linux26/libdde_linux26/mk/rel2abs.sh')
-rwxr-xr-xlibdde-linux26/libdde_linux26/mk/rel2abs.sh72
1 files changed, 72 insertions, 0 deletions
diff --git a/libdde-linux26/libdde_linux26/mk/rel2abs.sh b/libdde-linux26/libdde_linux26/mk/rel2abs.sh
new file mode 100755
index 00000000..33dd8a5b
--- /dev/null
+++ b/libdde-linux26/libdde_linux26/mk/rel2abs.sh
@@ -0,0 +1,72 @@
+#! /bin/bash
+#
+# Convert relative path to absolute one
+#
+# Adam Lackorzynski <adam@os.inf.tu-dresden.de>
+#
+
+help()
+{
+ echo PWD=\$PWD $0 relpath1 [relpath2 [..]]
+ exit $1
+}
+
+convertpath()
+{
+ relpath=$1
+ basepath=$PWD
+ # sanity checks
+ [ -z "$relpath" -o -z "$basepath" ] && help 1
+ [ "${basepath#/}" = "${basepath}" ] && help 1
+ [ "${basepath/\/..\//}" = "${basepath}" ] || help 1
+ [ "${basepath/\/.\//}" = "${basepath}" ] || help 1
+ [ "${basepath/%\/../}" = "${basepath}" ] || help 1
+ [ "${basepath/%\/./}" = "${basepath}" ] || help 1
+
+
+ # remove slashes at the end
+ while [ "${relpath%/}" != "${relpath}" ];
+ do relpath="${relpath%/}"; done
+
+ # remove double/multi slashes
+ while [ "${relpath/\/\///}" != "${relpath}" ];
+ do relpath=${relpath/\/\///}; done
+
+ # is relpath relative?
+ if [ "${relpath#/}" != "${relpath}" ]; then
+ basepath=''
+ relpath=${relpath#/}
+ fi
+
+ relpath="$relpath/"
+
+ while [ -n "$relpath" ];
+ do
+ elem=${relpath%%/*}
+ relpath=${relpath#*/}
+
+ case $elem in
+ .) # skip
+ ;;
+ ..)
+ basepath=${basepath%/*}
+ ;;
+ *)
+ basepath=$basepath/$elem
+ ;;
+ esac
+
+ done
+
+ [ -z "$basepath" ] && basepath=/$basepath
+
+ echo $basepath
+}
+
+while [ -n "$1" ];
+do
+ convertpath $1
+ shift
+done
+
+exit 0